/**
 *    author:  tourist
 *    created: 13.10.2023 01:18:02       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int h, w, k;
  cin >> h >> w >> k;
  vector<string> s(h);
  for (int i = 0; i < h; i++) {
    cin >> s[i];
  }
  int si, sj, fi, fj;
  cin >> si >> sj >> fi >> fj;
  --si; --sj; --fi; --fj;
  vector<vector<int>> d(h, vector<int>(w, k + 1));
  d[si][sj] = 0;
  vector<pair<int, int>> que;
  que.emplace_back(si, sj);
  vector<vector<bool>> in_que(h, vector<bool>(w));
  in_que[si][sj] = true;
  for (int b = 0; b < (int) que.size(); b++) {
    auto p = que[b];
    in_que[p.first][p.second] = false;
    for (int di = -1; di <= 1; di++) {
      for (int dj = -1; dj <= 1; dj++) {
        if (di * di + dj * dj == 1) {
          for (int u = 1; u <= 2; u++) {
            int ni = p.first + di * u;
            int nj = p.second + dj * u;
            if (ni >= 0 && nj >= 0 && ni < h && nj < w) {
              if (s[ni][nj] == '.') {
                int nd = d[p.first][p.second] + (u - 1);
                if (nd < d[ni][nj]) {
                  d[ni][nj] = nd;
                  if (!in_que[ni][nj]) {
                    que.emplace_back(ni, nj);
                    in_que[ni][nj] = true;
                  }
                }
              }
            }
          }
        }
      }
    }
  }
  cout << (d[fi][fj] <= k ? "YES" : "NO") << '\n';
  return 0;
}
