#include "jngen.h"
#include <iostream>
#include <vector>
#include <string>

using namespace std;

int main(int argc, char* argv[]) {
	parseArgs(argc, argv);
	
	int n = getOpt(0);
	string t = getOpt(1);
	
	cout << n << '\n';
	
	if (t == "random") {
		int cnt = getOpt(2);
		vector <string> s(cnt);
		for (int i = 0; i < cnt; i++)
			s[i] = rnds.random(10, "0-9a-zA-Z");
		for (int i = 0; i < n; i++)
			cout << s[rnd.next(cnt)] << '\n';
	}
	if (t == "numbers") {
		int cnt = getOpt(2);
		vector <string> s(cnt);
		for (int i = 0; i < cnt; i++) {
			int len = rnd.next(10) + 1;
			s[i] = rnds.random(len, "0-9");
		}
		for (int i = 0; i < n; i++)
			cout << s[rnd.next(cnt)] << '\n';
	}
	if (t == "small_numbers") {
		int cnt = getOpt(2);
		vector <string> s(cnt);
		for (int i = 0; i < cnt; i++) {
			int len = rnd.next(2) + 1;
			s[i] = rnds.random(len, "0-9");
		}
		for (int i = 0; i < n; i++)
			cout << s[rnd.next(cnt)] << '\n';
	}
	if (t == "lot_ones") {
		int cnt = getOpt(2);
		vector <string> s(10 * cnt);
		for (int i = 0; i < cnt; i++) {
			s[10 * i] = rnds.random(1, "a-zA-Z");
			for (int j = 1; j < 10; j++)
				s[10 * i + j] = s[10 * i + j - 1] + "1";
		}
		for (int i = 0; i < n; i++)
			cout << s[rnd.next(10 * cnt)] << '\n';
	}
	if (t == "end_in_nums") {
		int cnt = getOpt(2);
		string h = to_string(cnt);
		string st = rnds.random(10 - h.length(), "a-zA-Z");
		cnt++;
		vector <string> s(cnt);
		s[0] = st;
		for (int i = 1; i < cnt; i++) {
			s[i] = st + to_string(i);
		}
		for (int i = 0; i < n; i++)
			cout << s[rnd.next(cnt)] << '\n';
	}
	if (t == "small_end") {
        int cnt = getOpt(2);
		string st = rnds.random(5, "a-zA-Z");
		vector <string> s(cnt);
		for (int i = 0; i < cnt; i++) {
		    int len = rnd.next(2) + 1;
			s[i] = st + rnds.random(len, "0-9");
		}
		for (int i = 0; i < n; i++)
			cout << s[rnd.next(cnt)] << '\n';
	}
	if (t == "some_numbers") {
		int cnt = getOpt(2);
		vector <string> s(cnt);
		for (int i = 0; i < cnt; i++)
			s[i] = rnds.random(10, "0-9a-f");
		for (int i = 0; i < n; i++)
			cout << s[rnd.next(cnt)] << '\n';
	}
	if (t == "int_killer") {
        int cnt = getOpt(2);
		vector <string> s(2 * cnt);
		for (int i = 0; i < cnt; i++) {
		    long long num = rnd.next((long long)1000000000, 9999999999);
		    int tn = (int)num;
		    s[2 * i] = to_string(num);
		    s[2 * i + 1] = to_string(max(0, tn));
		}
		for (int i = 0; i < n; i++)
			cout << s[rnd.next(2 * cnt)] << '\n';
	}
	
	return 0;
}