/**
 *    author:  tourist
 *    created: 13.10.2023 00:46:40       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  long long n, k;
  cin >> n >> k;
  long long s1, s2;
  cin >> s1 >> s2;
  if (n == 1) {
    auto x = (1 <= s1 && s1 <= k);
    auto y = (1 <= s2 && s2 <= k);
    cout << (x && !y ? "First" : (!x && y ? "Second" : "Equal")) << '\n';
    return 0;
  }
  long long mid = (k + 1) * n;
  s1 *= 2;
  s2 *= 2;
  s1 = min(max(s1, 2 * n - 1), 2 * k * n + 1);
  s2 = min(max(s2, 2 * n - 1), 2 * k * n + 1);
  auto x = abs(s1 - mid);
  auto y = abs(s2 - mid);
  cout << (x < y ? "First" : (x > y ? "Second" : "Equal")) << '\n';
  return 0;
}
