#include "half_gen.h"
#include <iostream>
#include <vector>
using namespace std;

int main(int argc, char *argv[])
{
	registerGen(argc, argv, 1);
	parseArgs(argc, argv);
	
	int q = getOpt(0);
	string t = getOpt(1);
	
	if (t == "random") {
		int x = getOpt(4);
		int y = getOpt(5);
		auto poly = half_main(argc - 3, argv + 3);
		int n = (int)poly.size();
		cout << n << '\n';
		for (auto e : poly)
			cout << e.first << ' ' << e.second << '\n';
		cout << q << '\n';
		while (q--) {
			cout << rnd.next(-x, x) << ' ';
			cout << rnd.next(-y, y) << '\n';
		}
	}
	if (t == "to_side") {
		string mov = getOpt(2);
		int mx = getOpt(3);
		int my = getOpt(4);
		int x = getOpt(7);
		int y = getOpt(8);
		auto poly = half_main(argc - 6, argv + 6);
		int n = (int)poly.size();
		cout << n << '\n';
		int dx = 0, dy = 0;
		if (mov == "s") dx = x - mx;
		if (mov == "n") dx = mx - x;
		if (mov == "w") dy = y - my;
		if (mov == "e") dy = my - y;
		if (mov == "sw") dx = x - mx, dy = y - my;
		if (mov == "se") dx = x - mx, dy = my - y;
		if (mov == "nw") dx = mx - x, dy = y - my;
		if (mov == "ne") dx = mx - x, dy = my - y;
		for (auto e : poly)
			cout << e.first + dy << ' ' << e.second + dx << '\n'; //mixed up dx and dy with n/s and w/e
		cout << q << '\n';
		while (q--) {
			cout << rnd.next(-mx, mx) << ' ';
			cout << rnd.next(-my, my) << '\n';
		}
	}
	if (t == "small_in_corner") {
		string mov = getOpt(2);
		int mx = getOpt(3);
		int my = getOpt(4);
		if (mov == "sw") {
			cout << "3\n";
			cout << -mx << ' ' << -my << '\n';
			cout << -mx + 1 << ' ' << -my << '\n';
			cout << -mx << ' ' << -my + 1 << '\n';
		}
		if (mov == "se") {
			cout << "3\n";
			cout << mx << ' ' << -my << '\n';
			cout << mx << ' ' << -my + 1 << '\n';
			cout << mx - 1 << ' ' << -my << '\n';
		}
		if (mov == "nw") {
			cout << "3\n";
			cout << -mx << ' ' << my << '\n';
			cout << -mx << ' ' << my - 1 << '\n';
			cout << -mx + 1 << ' ' << my << '\n';
		}
		if (mov == "ne") {
			cout << "3\n";
			cout << mx << ' ' << my << '\n';
			cout << mx - 1 << ' ' << my << '\n';
			cout << mx << ' ' << my - 1 << '\n';
		}
		cout << q << '\n';
		while (q--) {
			cout << rnd.next(-mx, mx) << ' ';
			cout << rnd.next(-my, my) << '\n';
		}
	}
	if (t == "needle") {
		string mov = getOpt(2);
		int mx = getOpt(3);
		int my = getOpt(4);
		if (mov == "sw") {
			cout << "3\n";
			cout << -mx << ' ' << -my << '\n';
			cout << mx << ' ' << my << '\n';
			cout << -mx << ' ' << -my + 1 << '\n';
		}
		if (mov == "se") {
			cout << "3\n";
			cout << mx << ' ' << -my << '\n';
			cout << -mx << ' ' << my << '\n';
			cout << mx - 1 << ' ' << -my << '\n';
		}
		if (mov == "nw") {
			cout << "3\n";
			cout << -mx << ' ' << my << '\n';
			cout << mx << ' ' << -my << '\n';
			cout << -mx + 1 << ' ' << my << '\n';
		}
		if (mov == "ne") {
			cout << "3\n";
			cout << mx << ' ' << my << '\n';
			cout << -mx << ' ' << -my << '\n';
			cout << mx << ' ' << my - 1 << '\n';
		}
		cout << q << '\n';
		while (q--) {
			cout << rnd.next(-mx, mx) << ' ';
			cout << rnd.next(-my, my) << '\n';
		}
	}
	
	return 0;
}
