#include <bits/stdc++.h>

using namespace std;

int main() {
    const int INF = 1e8;
    int n, x;
    cin >> n;
    vector<int> dist(2 * n, INF);
    vector<vector<pair<int, int>>> g(2 * n);
    for (int i = 0; i < n; ++i) {
        if (!i || i == n - 1) {
            x = 0;
        }
        else {
            cin >> x;
        }
        if (x) {
            g[i].emplace_back(make_pair(i - x, 0));
            g[i + n].emplace_back(make_pair(i - x + n, 0));
            continue;
        }
        for (int j = 1; j < 6 && i + j < n; ++j) {
            g[i].emplace_back(make_pair(i + j, 1));
            g[i + n].emplace_back(i + j, 0);
        }
        if (i + 6 < n) {
            g[i].emplace_back(make_pair(i + 6 + n, 1));
            g[i + n].emplace_back(make_pair(i + 6 + n, 0));
        }
    }
    deque<int> q;
    q.emplace_back(0);
    dist.front() = 0;
    while (!q.empty()) {
        int cur = q.front();
        q.pop_front();
        for (auto[i, w] : g[cur]) {
            if (dist[i] > dist[cur] + w) {
                dist[i] = dist[cur] + w;
                w ? q.emplace_back(i) : q.emplace_front(i);
            }
        }
    }
    int ans = min(dist[n - 1], dist.back());
    cout << (ans == INF ? -1 : ans);
    return 0;
}