/**
 *    author:  tourist
 *    created: 13.10.2023 00:37:04       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  long long n, k;
  cin >> n >> k;
  long long low = 1, high = n;
  while (low < high) {
    long long mid = (low + high + 1) >> 1;
    long long x = k / 2;
    long long y = (k + 1) / 2;
    long long sum = x * (mid / 2) + y * ((mid + 1) / 2);
    if (sum + mid <= n) {
      low = mid;
    } else {
      high = mid - 1;
    }
  }
  cout << low << '\n';
  return 0;
}
