#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
using ll = long long;

unordered_map<string, unordered_set<ll>> numbers_suffix;

void solve()
{
    int q;
    cin >> q;
    while (q--) {
        string name;
        cin >> name;
        int word_end = name.size();
        while (word_end && isdigit(name[word_end - 1]))
            --word_end;
        while (word_end < name.size() && name[word_end] == '0')
            ++word_end;
        ll number = 0;
        for (int i = word_end; i < name.size(); ++i)
            number = number * 10 + name[i] - '0';
        name.resize(word_end);

        ll pow10 = 1, counter = 0;
        auto& numbers_list = numbers_suffix[name];
        while (true) {
            const auto try_add = number * pow10 + counter;
            ++counter;
            if (counter == pow10)
                pow10 *= 10;
            if (numbers_list.insert(try_add).second) {
                cout << name;
                if (try_add)
                    cout << try_add;
                cout << endl;
                break;
            }
        }
    }
}

int main()
{
#ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif // MY
    numbers_suffix.reserve(1e6);
    solve();
}
