#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

const long double EPS = 1e-9;

int main() {
	int n;
	long long k;
	cin >> n >> k;
	
	long double k0 = 0;
	vector <pair <int, int>> s(n);
	for (int i = 0; i < n; i++)
		cin >> s[i].first;
	for (int i = 0; i < n; i++) {
		cin >> s[i].second;
		k0 += (long double)abs(s[i].second - s[i].first) / s[i].first;
	}
	
	sort(s.begin(), s.end());
	
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		while (k0 > k + EPS && s[i].first != s[i].second) {
			k0 -= 1.0 / s[i].first;
			ans++;
			if (s[i].second > s[i].first) s[i].second--;
			else s[i].second++;
		}
	}
	
	cout << ans << '\n';
	
	return 0;
}